import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  extent,
  axisLeft,
  axisBottom,
  line,
  max
} from 'd3';
//Selects the svg 
const svg = select('svg');
//Sets svg width and height
const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => { //expliquer
  
const xValue = d => d.year; //display year value on x axis and takes year as xValue
const xAxisLabel = 'Year';

  const yValue = d => d.profits;//Takes profits as yValue
  const yAxisLabel = 'Profits';
  //Sets the margin top,right,bottom and left
  const margin = { top: 60, right: 40, bottom: 88, left: 150 };//mm manière que CSS
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  //sets xScale using scaleTime()
  
  const xScale = scaleTime()
  //complete set of values
    .domain(extent(data, xValue)) //returns the minimum and maximum value in an array from the given array using natural order.
    .range([0, innerWidth]) //output bounds
    .nice(); //round values out
  //sets xScale using scaleTime()
  const yScale = scaleLinear()
    .domain([0, max(data, yValue )])
    .range([innerHeight, 0])
    .nice();
 //Perform transform and translate functions  
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);//center g in svg
//Sets axisBottom
  const xAxis = axisBottom(xScale)
    .tickSize(-innerHeight)
    .tickPadding(20);
//Sets axisLeft
  const yAxis = axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(10);

  const yAxisG = g.append('g').call(yAxis);
  	yAxisG.selectAll('.domain').remove();
  
  yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -90)
      .attr('x', -innerHeight / 3)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .text(yAxisLabel);
  
  const xAxisG = g.append('g').call(xAxis)
    	.attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 70)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabel);
  
  const lineGenerator = line()
  	.x(d => xScale(xValue(d)))
  	.y(d => yScale(yValue(d))); //coordinates in pixels
  
  g.append('path')
  	.attr('class', 'line_path')
  	.attr('d', lineGenerator(data))
    console.log(lineGenerator(data))
  
  g.append('text')
      .attr('class', 'title')
      .attr('y', -10)
      .text(title);
};
//gets csvURL for the data created
csv('https://gist.githubusercontent.com/Tejaswi221/9e88652015da54a0fec7749298d907cc/raw/836f2a520ec008c548a9a4b9df45e187fe583ec3/Profits%2520of%2520a%2520Company')
  .then(data => {
  	//console.log(data)
    data.forEach(d => {
    	d.profits= +d.profits;
      d.year = new Date(d.year)
    });
  console.log(data)
    render(data);
  })